import sys

# Hash Values for words in New File
# HashNewFile[i,j] = Hash value of lines i to j in New File

HashNewFile = []

# Hash Values for words in Old File
# HashOldFile[i,j] = Hash value of lines i to j in Old File

HashOldFile = []

# Words in the New and Old File

wordsNew = []
wordsOld = []

# n : number of lines in each file

n = 1 # default value


# variable to measure network transmission cost

count=0

# penalty value for transmitting the whole word

penalty=4





def compute_node_values():
''' Compute the binary tree of Hash Values HashNewFile, HashOldFile
using the hash composition function to compose hash value of child nodes
HashNewFile[i][j] = hash_compose(hash_lef_child, hash_right_child, i, j)
'''

################ Complete the code here ###########

    return


def binary_check_hash(left,right):
''' performs binary search over the binary tree of hash values, if a
node's hash value is same in both trees the nodes below it in its
subtree are ignored. The penalty (send_word()) is added to the
transmission cost if the hashes do no match for a word (for leaf
nodes)
'''
    global count,penalty

################# Complete the code here #########

    return


# Compute the hash values of the leaf nodes in the Hash Tree

def compute_hash_tree():
    for i in range(n):
        HashNewFile.append([])
        HashOldFile.append([])
        for j in range(n):
            HashNewFile[i].append(None)
            HashOldFile[i].append(None)
    
    for i in range(n):
        HashNewFile[i][i] = hash_function(wordsNew[i])
        HashOldFile[i][i] = hash_function(wordsOld[i])

    compute_node_values()


# compute the hash value of the string

def hash_function(s):

################# Complete the code here #########
    

# read the two versions of file file1 and file2

def read_files(file1, file2):
    f1 = open(file1, 'r')
    f2 = open(file2, 'r')
    for line in f1:
        wordsNew.append(line)
    for line in f2:
        wordsOld.append(line)
    f1.close()
    f2.close()


# compares the two hash values, adds 1 to the network transmission cost
def compare(oldhash, newhash):
    global count
    count = count + 1
    return oldhash == newhash


# adds the penalty of sending the whole word over network transmission
def send_word():
    global count,penalty
    count = count + penalty


 



# naive hash check method, goes over all the lines and compares
# them. Adds the penalty (send_word()) to the cost if the hashes do
# not match

def naive_check_hash(left,right):
    global count,penalty

    for i in xrange(left,right+1):
        if not compare(HashNewFile[i][i],HashOldFile[i][i]):
            send_word()




# performs the naive file transfer algorithm and binary_check_hash
# algorithm and compares the transmission cost on filename1 and
# filename2 with n lines each,

def file_transfer(filename1, filename2, n1):
    global count,n

    n=n1

    read_files(filename1,filename2)

    compute_hash_tree()


    count = 0
    naive_check_hash(0,n-1)
    print "naive_check_hash count=",count

    count = 0

    binary_check_hash(0,n-1)
    print "binary_check_hash count=",count
    return count



if __name__ == "__main__":
    file_transfer("file_new.txt","file_old.txt",1024)
    
