#!/usr/bin/python

import file_transfer_skeleton as filetransfer
import unittest
import time

class TestFileTransfer(unittest.TestCase):
    def test1(self):
        ans = filetransfer.file_transfer('file_new.txt','file_old.txt',1024)
        self.assertEqual(ans, 87)
    def test2(self):
        ans = filetransfer.file_transfer('file_new1.txt','file_old1.txt',4096)
        self.assertEqual(ans, 351)
    def test3(self):
        ans = filetransfer.file_transfer('file_new2.txt','file_old2.txt',16384)
        self.assertEqual(ans, 1407)
        

if __name__ == '__main__':
    suite = unittest.TestLoader().loadTestsFromTestCase(TestFileTransfer)
    unittest.TextTestRunner(verbosity=2).run(suite)
    
